using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.DailyTasks;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.DailyInventoryDiarys
{
    public interface IDailyInventoryDiaryRepository
    {
        Task<BaseResult> Add(InventoryDiaryElastic DailyInventoryDiary);
        Task<BaseResult> AddManyAsync(IEnumerable<InventoryDiaryElastic> DailyInventoryDiarys);
        Task<BulkResponse> DeleteDailyInventoryDiarys(IEnumerable<InventoryDiaryElastic> DailyInventoryDiarys);
        Task<DeleteByQueryResponse> DeleteByIds(IEnumerable<long> ids);
        Task<SmartTableResult<InventoryDiaryElastic>> SearchForExcel(BoolQueryDescriptor<InventoryDiaryElastic> query);
        Task<SmartTableResult<InventoryDiaryElastic>> GetByIds(List<long> ids);

    }
    public class DailyInventoryDiaryRepository : IDailyInventoryDiaryRepository
    {
        private readonly ElasticIndex<InventoryDiaryElastic> _dbContext;

        public DailyInventoryDiaryRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<InventoryDiaryElastic>(settings.Value.ClusterUrl, "dailyinventorydiary");
        }

        #region  search

        public async Task<SmartTableResult<InventoryDiaryElastic>> SearchForExcel(BoolQueryDescriptor<InventoryDiaryElastic> query)
        {
            return await _dbContext.Search(query);
        }

        #endregion

        #region Add order

        public async Task<BaseResult> Add(InventoryDiaryElastic DailyInventoryDiary)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(DailyInventoryDiary);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<InventoryDiaryElastic> DailyInventoryDiarys)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(DailyInventoryDiarys);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteDailyInventoryDiarys(IEnumerable<InventoryDiaryElastic> DailyInventoryDiarys)
        {
            return await _dbContext.DeleteMany(DailyInventoryDiarys);
        }

        public async Task<DeleteByQueryResponse> DeleteByIds(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        public async Task<SmartTableResult<InventoryDiaryElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<InventoryDiaryElastic>();
            var idsQ = new QueryContainerDescriptor<InventoryDiaryElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        #endregion
    }
}
